<?php 

class kundenmeister_api{
	
	var $response_code;
	var $response_message;
	
	public function km_post_request($end_point,$data = array()){
		$api_url ="https://api.kundenmeister.com/v13/";
		$km_accessToken = get_option("km_accessToken",true);
		
		//$body = json_encode($data);
		$body = json_encode($data);
		$response_hooks = wp_remote_post($api_url.$end_point, array(
			'body'    =>$body,
			'timeout'    => 120,
			'headers' => array(
				'content-type' => 'application/json',
				'token' => $km_accessToken
			),
		) );
		
		$this->response_code = wp_remote_retrieve_response_code($response_hooks);
		$response_data     = json_decode(wp_remote_retrieve_body($response_hooks),true);
		
		if($this->response_code!== 200){ 		
			$this->response_message = isset($response_data["message"])? $response_data["message"]: "";
			 
			return $response_data;
		}
		
		return $response_data;
	}
	
	public function km_get_request($end_point,$data = array()){
		$api_url ="https://api.kundenmeister.com/v13/";
		$km_accessToken = get_option("km_accessToken",true);
		 
		//$body = json_encode($data);
		$body = $data;
		$response_hooks = wp_remote_get($api_url.$end_point, array(
			'body'    =>$body,
			'timeout'    => 120,
			'headers' => array(
				'content-type' => 'application/json',
				'token' => $km_accessToken
			),
		) );
		
		$this->response_code = wp_remote_retrieve_response_code($response_hooks);
		$response_data     = json_decode(wp_remote_retrieve_body($response_hooks),true);
		
		if($this->response_code!== 200){ 		
			$this->response_message = isset($response_data["message"])? $response_data["message"]: "";
			 
			return $response_data;
		}
		
		return $response_data;
	} 

	
}


?>